functor PPrint(ImpAst : IMPAST) : PPRINT = struct
  
  structure ImpAst = ImpAst

  fun pprintLoc l = print l

  local 
    open ImpAst
  in
    fun NSpace 0 = ()
      | NSpace n = (print " "; NSpace(n-1))


    fun pprintAexp(N m) = print(Int.toString m)
      | pprintAexp(Loc l) = pprintLoc l
      | pprintAexp(Plus(a1, a2)) = (print "("; pprintAexp(a1); print " + "; pprintAexp(a2); print ")")
      | pprintAexp(Minus(a1, a2)) = (print "("; pprintAexp(a1); print " - "; pprintAexp(a2); print ")")
      | pprintAexp(Times(a1, a2)) = (print "("; pprintAexp(a1); print " * "; pprintAexp(a2); print ")")

    fun	pprintBexp(True) = print "true"
      | pprintBexp(False) = print "false"
      | pprintBexp(Equals(a1, a2)) = (print "("; pprintAexp(a1); print " = "; pprintAexp(a2); print ")")
      | pprintBexp(LessEq(a1, a2)) = (print "("; pprintAexp(a1); print " <= "; pprintAexp(a2); print ")")
      | pprintBexp(Not(b)) = (print "not "; pprintBexp(b))
      | pprintBexp(And(b1, b2)) = (print "("; pprintBexp(b1); print " and "; pprintBexp(b2); print ")")
      | pprintBexp(Or(b1, b2)) = (print "("; pprintBexp(b1); print " or "; pprintBexp(b2); print ")")
      | pprintBexp(Implies(b1, b2)) = (print "("; pprintBexp(b1); print " => "; pprintBexp(b2); print ")")

   fun pprintCom' (n, Skip) = (NSpace n; print "skip")
      | pprintCom' (n, Assign(l, a)) = (NSpace n; pprintLoc l; print " := "; pprintAexp a)
      | pprintCom' (n, Seq(c1, c2)) = (pprintCom'(n, c1); print ";\n"; pprintCom'(n, c2))
      | pprintCom' (n, Cond(b, c1, c2)) = (NSpace n; print "if "; pprintBexp b; print " then {\n";
					   pprintCom'(n+2, c1); print "\n"; NSpace n; print "} else {\n";
					   pprintCom'(n+2, c2); print "\n"; NSpace n; print "}")
      | pprintCom' (n, While(a, b, c)) = (NSpace n; print "while {"; pprintBexp a; print "} ";
                                        pprintBexp b; print " {\n";
				        pprintCom'(n+2, c); print "\n"; NSpace n; print "}")
      | pprintCom' (n, ForLoop(d, l, m1, m2, c)) = 
				        (NSpace n; print "for  { "; 
                                        pprintBexp d; print "} (";
					pprintLoc l; print " = ";
					print(Int.toString m1); print " to ";
					print(Int.toString m2); print ") {\n";
				        pprintCom'(n+2, c); print "\n"; 
                                        NSpace n; print "}" )

    fun pprintCom c = pprintCom'(0, c)

    fun pprintProgram (AnnotatedProg(a1, c, a2)) = 
                  (print "{";pprintBexp(a1); print "}\n"; 
                   pprintCom(c); print "\n"; 
                   print "{";pprintBexp(a2); print "}") 

  end

end


